#!/bin/bash

# 建立cPanel 帳號之陣列
user_array=($(cat /etc/trueuserdomains |awk '{print $2}'))
user_array_string=$(printf "%s\n" "${user_array[@]}")

verify_account=""

ssl_cipher="SSLCipherSuite ECDHE-ECDSA-CHACHA20-POLY1305:ECDHE-RSA-CHACHA20-POLY1305:ECDHE-ECDSA-AES128-GCM-SHA256:ECDHE-RSA-AES128-GCM-SHA256:ECDHE-ECDSA-AES256-GCM-SHA384:ECDHE-RSA-AES256-GCM-SHA384:DHE-RSA-AES128-GCM-SHA256:DHE-RSA-AES256-GCM-SHA384:ECDHE-ECDSA-AES128-SHA256:ECDHE-RSA-AES128-SHA256:ECDHE-ECDSA-AES128-SHA:ECDHE-RSA-AES256-SHA384:ECDHE-RSA-AES128-SHA:ECDHE-ECDSA-AES256-SHA384:ECDHE-ECDSA-AES256-SHA:ECDHE-RSA-AES256-SHA:DHE-RSA-AES128-SHA256:DHE-RSA-AES128-SHA:DHE-RSA-AES256-SHA256:DHE-RSA-AES256-SHA:AES128-GCM-SHA256:AES256-GCM-SHA384:AES128-SHA256:AES256-SHA256:AES128-SHA:AES256-SHA:!DSS"

restart_string="最後請自行決定重啟 apache 的時機，輸入以下指令:\n\n/scripts/rebuildhttpdconf\n/scripts/restartsrv_httpd\n"


#清除畫面
clear

# 如果沒輸入帳號
if [ -z "$1" ]; then
    echo "沒輸入 cPanel 帳號"
    echo ""
    exit
else
    # 判斷輸入帳號有沒有符合
    if echo ${user_array_string} | grep -q -w "$1"; then
	verify_account="true"
    else
	echo "此 cPanel 帳號不存在"
	echo ""
	exit
    fi
fi


if [ $verify_account == "true" ]; then
    # 確認目錄是否存在，如果不存在，則創建
    if [ ! -d "/etc/apache2/conf.d/userdata/ssl/2_4/$1" ]; then
        mkdir -p /etc/apache2/conf.d/userdata/ssl/2_4/$1
	echo "$ssl_cipher" > /etc/apache2/conf.d/userdata/ssl/2_4/$1/ssl.conf
	echo "設定完畢，可至/etc/apache2/conf.d/userdata/ssl/2_4/$1/ssl.conf 確認設定"
	echo ""
	echo -e $restart_string
	echo ""
    else
	# 判斷目錄底下是不是有 *.conf
	conf_result=$(find /etc/apache2/conf.d/userdata/ssl/2_4/$1 -type f -name "*.conf")
	if [ -n "conf_result" ]; then
            echo -e "$1 此 cPanel 帳號已有先行建立設定檔目錄，\n請至 /etc/apache2/conf.d/userdata/ssl/2_4/$1 目錄確認設定檔"
	    echo ""
	    echo "自訂義設定檔路徑如下:"
            for file_path in $conf_result; do
                echo $file_path
            done
            echo ""
	    echo "依情況判斷是否要將下述設定加至設定檔中:"
	    echo ""
	    echo $ssl_cipher
	    echo ""
	    echo ""
            echo -e $restart_string

	else
	    # 雖然有目錄，但底下沒有設定檔的情況
	    echo "$ssl_cipher" > /etc/apache2/conf.d/userdata/ssl/2_4/$1/ssl.conf
	    echo "設定完畢，可至/etc/apache2/conf.d/userdata/ssl/2_4/$1/ssl.conf 確認設定"
	    echo ""
	    echo ""
            echo -e $restart_string
	fi
    fi
     
else
    "程式執行有問題，請告知二線確認"
    echo ""
fi
